#include <bits/stdc++.h>

using namespace std;

bool cheak2(long long l1, long long l2, long long l3, vector<long long> tr5, vector<long long> tr6, vector<long long> tr7) {
    bool is1 = false;
    bool is2 = false;
    bool is3 = false;
    if (find(tr5.begin(), tr5.end(), l1) != tr5.end()) {
        is1 = true;
    }
    if (find(tr6.begin(), tr6.end(), l2) != tr6.end()) {
        is2 = true;
    }
    if (find(tr7.begin(), tr7.end(), l3) != tr7.end()) {
        is3 = true;
    }
    if (is1 && is2 && is3) {
        vector<pair<long long, long long>> pov1;
        for (long long i = 0; i < 3; i++) {
            if (tr5[i] == l1) {
                pov1.push_back({(i + 1) % 3, (i + 2) % 3});
            }
        }
        vector<pair<long long, long long>> pov2;
        for (long long i = 0; i < 3; i++) {
            if (tr6[i] == l2) {
                pov2.push_back({(i + 1) % 3, (i + 2) % 3});
            }
        }
        vector<pair<long long, long long>> pov3;
        for (long long i = 0; i < 3; i++) {
            if (tr7[i] == l3) {
                pov3.push_back({(i + 1) % 3, (i + 2) % 3});
            }
        }
        for (auto k1 : pov1) {
            for (auto k2 : pov2) {
                for (auto k3 : pov3) {
                    double le1 = sqrt(tr5[k1.second]) + sqrt(tr6[k2.first]);
                    double le2 = sqrt(tr6[k2.second]) + sqrt(tr7[k3.first]);
                    double le3 = sqrt(tr7[k3.second]) + sqrt(tr5[k1.first]);
                    if (le1 + le2 > le3 and
                    le1 + le3 > le2 and le2 + le3 > le1) {
                        return true;
                    }
                }
            }
        }
    }
    return false;
}


bool cheak(vector<long long> tr1, vector<long long> tr2, vector<long long> tr3, vector<long long> tr4) {
    bool t1 = cheak2(tr1[0], tr1[1], tr1[2], tr2, tr3, tr4);
    bool t2 = cheak2(tr1[1], tr1[2], tr1[0], tr2, tr3, tr4);
    bool t3 = cheak2(tr1[2], tr1[0], tr1[1], tr2, tr3, tr4);
    return t1 or t2 or t3;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long t, n, x1, y1, x2, y2, x3, y3, s1, s2, s3;
    cin >> t;
    cin >> n;
    vector<vector<long long>> triagnles;
    for (long long i = 0; i < n; i++) {
        cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
        s1 = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
        s2 = (x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2);
        s3 = (x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3);
        triagnles.push_back({s1, s2, s3});
    }
    set<vector<long long>> ans;
    for (long long i = 0; i < n; i++) {
        for (long long g = 0; g < n; g++) {
            for (long long j = 0; j < n; j++) {
                for (long long k = 0; k < n; k++) {
                    if (i == g or i == j or i == k or g == j or g == k or j == k) {
                        continue;
                    }
                    if (cheak(triagnles[i], triagnles[g], triagnles[j], triagnles[k])) {
                        vector<long long> ans2;
                        ans2.push_back(i + 1);
                        ans2.push_back(g + 1);
                        ans2.push_back(j + 1);
                        ans2.push_back(k + 1);
                        sort(ans2.begin(), ans2.end());
                        ans.insert(ans2);
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto h : ans) {
        cout << h[0] << ' ' << h[1] << ' ' << h[2] << ' ' << h[3] << '\n';
    }
}